//
//  AnchorViewController.swift
//  TAMTutorial
//
//  Created by Jimmy Shih on 2021/7/8.
//  Copyright © 2021 TAMedia. All rights reserved.
//

import UIKit
import TAMediaAdsFramework

class AnchorViewController: UIViewController {
    @IBOutlet weak var resultLabel: UILabel!
    var anchorView: TADInReadAnchor?

    deinit {
        print(#function)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        requestAd()
    }

    func requestAd() {
        self.resultLabel.text = "Loading..."

        let request = TADRequest()
        request.setLocationWithLatitude(25.02246916213678, longitude: 121.54834205241194, accuracy: 1)
        request.showLog = true
        anchorView = TADInReadAnchor(anchorWith: self)
        anchorView?.adUnitID = Constants.AnchorAdSlotID
        anchorView?.delegate = self
        anchorView?.load(request)
    }
    
    @IBAction func backButtonPressed(_ sender: UIButton) {
        self.dismiss(animated: true, completion: nil)
    }
}

extension AnchorViewController: TADInReadAnchorDelegate {
    // 廣告取得成功
    func anchorDidReceiveAd(_ anchor: TADInReadAnchor!) {
        print(#function)
        self.resultLabel.text = "Receive AD"
    }

    // 廣告取得失敗
    func anchor(_ anchor: TADInReadAnchor!, didFailToReceiveAdWithError error: TADRequestError!) {
        print("Error:\(error.localizedDescription)")
        self.resultLabel.text = "Error:\(error.localizedDescription)"
    }

    // 廣告即將被呈現之前被呼叫
    func anchorWillShow(_ anchor: TADInReadAnchor!) {
        print(#function)
    }

    // 廣告被關閉之後被呼叫
    func anchorUserPressedCloseAd() {
        print(#function)
        //user關閉anchor後 須將廣告及delegate設為nil
        self.anchorView?.delegate = nil;
        self.anchorView = nil;
    }

    // 應用程式即將進入背景執行或中止運作前被呼叫
    func anchorWillLeaveApplication(_ anchor: TADInReadAnchor!) {
        print(#function)
    }

}
